#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2four4search.py">
#<abstract4xi abstract = "shoots to direction four"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2four4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2four4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2four4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4four

global count2ack4four
global count2nack4four
global count2found4four
global count2short4four

global current2series4four
global candidate2series4four

global fileobject4four  

global keys2profile4four
global key2profile4four

global left2find4four

global maxsize2ack4four    
global maxsize2file4four 
global max2short4four
global meansize2ack4four
global minsize2ack4four

global four2analyse4search

global profile2fetch4four

global right2find4four

global sumsize2ack4four    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4four = VersionKB4Xi['base2shoot4four']             # base internet address, None=local url

count2ack4four   = 0
count2nack4four  = 0
count2found4four = 0
count2short4four = 0

left2find4four = '('

max2short4four = VersionKB4Xi['max2short4four']
maxsize2file4four = VersionKB4Xi['maxsize2file4four']
maxsize2ack4four  = 0
meansize2ack4four = 0
minsize2ack4four  = 0

current2series4four = "current2series4four5dummy"
candidate2series4four  = "candidate2series4four5dummy"


four2analyse4search  = VersionKB4Xi['four2analyse4search']

profile2fetch4four = {}
profile2fetch4four [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4four [2] = '.jpg'
keys2profile4four = profile2fetch4four.keys()

right2find4four = ')'

sumsize2ack4four  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4four" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4four(target2explore4four):
    global count2ack4four
    global count2nack4four
    global count2found4four
    global count2short4four
    
    global fileobject4four 
       
    global keys2profile4four
    global key2profile4four
    
    global left2find4four

    global max2short4four    
    global maxsize2file4four     
    global maxsize2ack4four    
    global meansize2ack4four
    global minsize2ack4four
  
    global candidate2series4four
    global current2series4four
    
    
    global profile2fetch4four                         # extension for files
    
    global right2find4four
    
    global sumsize2ack4four    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4four = count2found4four + 1
    ack2debug4four = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4four)
    
    ack2profile = False
    for key2profile4four in keys2profile4four:
        if name2target[1] == profile2fetch4four[key2profile4four]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2FOUR4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4four
        if ack2debug4four is True:
            print("(STEP 0A/33) OF SHOOT2FOUR4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2FOUR4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4four:
            count2nack4four = count2nack4four + 1
        else:
            count2ack4four = count2ack4four + 1
            sumsize2ack4four = sumsize2ack4four + size2file
            if size2file > maxsize2ack4four:
                maxsize2ack4four = size2file
            if ((size2file < minsize2ack4four) or (minsize2ack4four == 0)):
                print("(STEP 0B/33) OF SHOOT2FOUR4SEARCH - USING MINSIZE2ACK4FOUR: ", minsize2ack4four, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4FOUR:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2four//d\fourfly29july2012\fourfly29july2012 (1).JPG 
                # USING MINSIZE2ACK4FOUR:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2four//d\fourfly29july2012\fourfly29july2012 (2).JPG
                minsize2ack4four = size2file
                print("(STEP 0C/33) OF SHOOT2FOUR4SEARCH - SET MINSIZE2ACK4FOUR TO: ", minsize2ack4four, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4FOUR TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2four//d\fourfly29july2012\fourfly29july2012 (1).JPG
                # SET MINSIZE2ACK4FOUR TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2four//d\fourfly29july2012\fourfly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4four = target2explore4four
            if ack2debug4four is True:print("(STEP 1A/33) OF SHOOT2FOUR4SEARCH - URL2WEB4FOUR: ", url2web4four) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4four,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4four = url2web4four[0:index2edit] + string2use + url2web4four[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4four)
            shortname2web4four = name2web[0]
            if ack2debug4four is True:
                print("(STEP 1B/33) OF SHOOT2FOUR4SEARCH - SHORTNAME2WEB4FOUR: ", shortname2web4four)
                # 
            
            string2find4four = '/'
            ackall2found4four = False           
            while 1:
                if ackall2found4four is True:
                    break
                else:
                    index2find4four=str.find(shortname2web4four,string2find4four)   
                    if index2find4four == -1:
                        ackall2found4four = True
                    else:
                        shortname2web4four = shortname2web4four[index2find4four+1:]
                        
            if ack2debug4four is True:            
                print("(STEP 1C/33) OF SHOOT2FOUR4SEARCH - SHORTNAME2WEB4FOUR: ", shortname2web4four)
                # 
                
            ackall2found4four = False 
            while 1:
                if ackall2found4four is True:
                    break
                else:
                    index2left4four=str.find(shortname2web4four,left2find4four)
                    if index2left4four == -1:
                        current2series4four = shortname2web4four
                        if ack2debug4four is True:
                            print("(STEP 2A/33) OF SHOOT2FOUR4SEARCH - CURRENT2SERIES4FOUR: ", current2series4four) 
                            # 
                        ackall2found4four = True
                         
                    else:
                        index2right4four=str.find(shortname2web4four,right2find4four)
                        if index2right4four == -1:
                            ackall2found4four = True 
                        else:
                            candidate2series4four = shortname2web4four[0:index2left4four]
                            
                            index3find4four=str.find(shortname2web4four,current2series4four)
                            if index3find4four == -1:
                                
                                current2series4four = candidate2series4four
                                if ack2debug4four is True:
                                    print("(STEP 2B/33) OF SHOOT2FOUR4SEARCH - CURRENT2SERIES4FOUR: ", current2series4four) 
                                    # 
                                
                                count2short4four = 0
                                fileobject4four.write('<br />' + '\n')
                            else:
                                shortname2web4four = shortname2web4four[index2left4four:index2right4four+1]
                                if ack2debug4four is True:
                                    print("(STEP 2C/33) OF SHOOT2FOUR4SEARCH - SHORTNAME2WEB4FOUR: ", shortname2web4four)
                                    # 
                                
                                count2short4four = count2short4four + 1
                                if count2short4four >= max2short4four:
                                    count2short4four = 0
                                else:
                                    pass       
                            ackall2found4four = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4four is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4four.write('<br /><b>&raquo;</b><a href="' + url2web4four + '" target="_blank">' + shortname2web4four + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4four = four2analyse4search
                if ack2debug4four is True:
                    print("(STEP 3A/33) OF SHOOT2FOUR4SEARCH - BASE2LOCAL4FOUR: ", base2local4four)
                    #              
                ack2localtries4four = False                   
                while 1:
                    if ack2localtries4four is True:
                        break
                    else:
                        index2find4four=str.find(url2web4four,base2local4four)            
                        # 
                        #  
                        if index2find4four == -1:
                            ack2localtries4four = True
                        else:
                            if ack2debug4four is True:
                                print("(STEP 3B/33) OF SHOOT2FOUR4SEARCH - BASE2BUILD4FOUR: ", base2build4four)
                                # 
                            url2web4four = base2build4four + url2web4four[len(base2local4four):]
                            if ack2debug4four is True:
                                print("(STEP 3C/33) OF SHOOT2FOUR4SEARCH - URL2WEB4FOUR: ", url2web4four)
                                # 
                            
                            if count2short4four < 1: 
                                fileobject4four.write('<br /><b>&raquo;</b><a href="' + url2web4four + '" target="_blank">' + shortname2web4four + '</a>' + '\n')
                            else:
                                fileobject4four.write('<b>&raquo;</b><a href="' + url2web4four + '" target="_blank">' + shortname2web4four + '</a>\n')                            
                            ack2localtries4four = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2FOUR4SEARCH FAILED, FILEOBJECT4FOUR-WRITE-FAILED: ", str(fileobject4four), time4xi())
      
    else:
        
        count2nack4four = count2nack4four + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2four4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2four4search(queue2four = None, consumer_channel2four = None, publisher_channel2four = None, path2four = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4four
    global count2nack4four
    global count2found4four
    
    global fileobject4four    
    
    global maxsize2ack4four    
    global meansize2ack4four
    global minsize2ack4four
    global sumsize2ack4four    
    
    global maxsize2file4four 
    
    global profile2fetch4four                         # extension for files
    global keys2profile4four
    global key2profile4four

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2FOUR4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2FOUR4SEARCH -  QUEUE2FOUR: ", queue2four)      
    # QUEUE2FOUR:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2FOUR4SEARCH -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
    # CONSUMER_CHANNEL2FOUR:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2FOUR4SEARCH -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
    # PUBLISHER_CHANNEL2FOUR:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2four is None) or (consumer_channel2four is None) or (publisher_channel2four is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2FOUR4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2FOUR4SEARCH - QUEUE2FOUR: ", queue2four)
        print("(STEP 1C/33) OF SHOOT2FOUR4SEARCH - CONSUMER_CHANNEL2FOUR: ", consumer_channel2four) 
        print("(STEP 1D/33) OF SHOOT2FOUR4SEARCH - PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)
        print("(STEP 1E/33) OF SHOOT2FOUR4SEARCH - PATH2FOUR: ", path2four)     
        
        return
 
    if (not (queue2four is None) and not(consumer_channel2four is None) and not(publisher_channel2four is None) and (path2four is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2FOUR4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2FOUR4SEARCH - QUEUE2FOUR: ", queue2four)
        print("(STEP 2C/33) OF SHOOT2FOUR4SEARCH - CONSUMER_CHANNEL2FOUR: ", consumer_channel2four) 
        print("(STEP 2D/33) OF SHOOT2FOUR4SEARCH - PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)
        print("(STEP 2E/33) OF SHOOT2FOUR4SEARCH - PATH2FOUR: ", path2four)     
        return           

    if (not (queue2four is None) and not(consumer_channel2four is None) and not(publisher_channel2four is None) and not(path2four is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2FOUR4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2FOUR4SEARCH - QUEUE2FOUR: ", queue2four)
        # QUEUE2FOUR:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2FOUR4SEARCH - CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # CONSUMER_CHANNEL2FOUR:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2FOUR4SEARCH - PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)
        # PUBLISHER_CHANNEL2FOUR:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2FOUR4SEARCH - PATH2FOUR: ", path2four)
        # PATH2FOUR:  F://temp//yophotos//test2four//
       
        print("(STEP 4A/33) OF SHOOT2FOUR4SEARCH - STARTING TO WALK PATH2FOUR: ", path2four)   
        # STARTING TO WALK PATH2FOUR:  F://temp//yophotos//test2four//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4four = None
        try:
            name2index4four = "index2xxxxxxxx4yo.html"
            path2index4four = path2four + name2index4four
            print("(Step 4B/33) OF SHOOT2FOUR4SEARCH - SET PATH2INDEX4FOUR TO: ", path2index4four)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2FOUR4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4FOUR: ", path2index4four)          
            #                    
        fileobject4four = None
        try:
            fileobject4four = open(path2index4four,'w')
            print("(Step 4C/33) OF SHOOT2FOUR4SEARCH - OPENED OUTPUT: ", fileobject4four)
            # SHOOT2FOUR4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2four//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2FOUR4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4four)         
            # 
        try:                
            fileobject4four.write('<html>\n')
            
            fileobject4four.write('<style type="text/css" media="all">\n')
            fileobject4four.write(' @import "http://www.yourfourxi.org/css/halongbay.css";\n')
            fileobject4four.write('</style> \n')
            fileobject4four.write('<p>\n')
            fileobject4four.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4four.write('<br /><a id="000">yourfour<b>&Xi;</b> @Content</a>\n')
            fileobject4four.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4four.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2FOUR4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4four)         
            #      
        
        
        KB2name4four = {}
        key2name4four = 0
                 
        for file2walk in DirectoryWalker(path2four):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4four [key2name4four] = file2walk
                    print ("KB2NAME4FOUR[", key2name4four, "]: ", KB2name4four [key2name4four])
                    # 
                    
                    key2name4four = key2name4four + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2FOUR4SEARCH - FAILED UPDATING KB2NAME4FOUR WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4four(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4four.write('<br /> \n')
            fileobject4four.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4four.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4four.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4four.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4four.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4four.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4four.write('</p>\n')
            # 
            fileobject4four.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2FOUR4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4four)         
            #            
        try:    
            fileobject4four.close()
            print("(Step 4C/33) OF SHOOT2FOUR4SEARCH - CLOSED OUTPUT: ", fileobject4four)         
            # SHOOT2FOUR4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2four//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2FOUR4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4four)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2FOUR4SEARCH - STARTING TO ANALYSE KB2NAME4FOUR: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4FOUR:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4four  = {}
        AlphaKB4four['a'] = {}
        AlphaKB4four['b'] = {}
        AlphaKB4four['c'] = {}
        AlphaKB4four['d'] = {}
        AlphaKB4four['e'] = {}
        AlphaKB4four['f'] = {}
        AlphaKB4four['g'] = {}
        AlphaKB4four['h'] = {}
        AlphaKB4four['i'] = {}
        AlphaKB4four['j'] = {}
        AlphaKB4four['k'] = {}
        AlphaKB4four['l'] = {}
        AlphaKB4four['m'] = {}
        AlphaKB4four['n'] = {}
        AlphaKB4four['o'] = {}
        AlphaKB4four['p'] = {}
        AlphaKB4four['q'] = {}
        AlphaKB4four['r'] = {}
        AlphaKB4four['s'] = {}
        AlphaKB4four['t'] = {}
        AlphaKB4four['u'] = {}
        AlphaKB4four['v'] = {}
        AlphaKB4four['w'] = {}
        AlphaKB4four['x'] = {}
        AlphaKB4four['y'] = {}
        AlphaKB4four['z'] = {} 
        keys2AlphaKB4four = AlphaKB4four.keys()
        key2AlphaKB4four  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4four = len(path2four)
        # 
        
        keys2name4four = KB2name4four.keys()
                
        for key2name4four in sorted(keys2name4four):
            # 
            name2optimize4four = KB2name4four[key2name4four]
            # 
            shortcut2level4four = name2optimize4four[len2cut4four:]
            # 
            len2shortcut4four = len(shortcut2level4four)
            if len2shortcut4four == 1:
                try:
                    # LEVEL FOUR CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4four in keys2AlphaKB4four:
                        KB2level1[key2level1] = shortcut2level4four
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2FOUR4SEARCH ** WARNING - SHORTCUT2LEVEL4FOUR: ", shortcut2level4four, " NOT IN KEYS2ALPHAKB4FOUR: ", keys2AlphaKB4four)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2FOUR4SEARCH *** FAILED - SHORTCUT2LEVEL4FOUR: ", shortcut2level4four)      
            else:
                try:
                    
                    string2search4four = '\\'
                    shortcut2level4four = shortcut2level4four[2:]
                    
                    index2level4four=str.find(shortcut2level4four,string2search4four)
                    if index2level4four == -1:
                         
                        KB2level2[key2level2] = shortcut2level4four
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4four = shortcut2level4four[index2level4four+1:]
                        index2level4four=str.find(shortcut2level4four,string2search4four)
                        if index2level4four == -1:
                            KB2level3[key2level3] = shortcut2level4four
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4four = shortcut2level4four[index2level4four+1:]
                            index2level4four=str.find(shortcut2level4four,string2search4four)
                            if index2level4four == -1:
                                KB2level4[key2level4] = shortcut2level4four
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4four = shortcut2level4four[index2level4four+1:]
                                index2level4four=str.find(shortcut2level4four,string2search4four)
                                if index2level4four == -1:
                                    KB2level5[key2level5] = shortcut2level4four
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4four = shortcut2level4four[index2level4four+1:]
                                    index2level4four=str.find(shortcut2level4four,string2search4four)
                                    if index2level4four == -1:
                                        KB2level6[key2level6] = shortcut2level4four
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4four = shortcut2level4four[index2level4four+1:]
                                        index2level4four=str.find(shortcut2level4four,string2search4four)
                                        if index2level4four == -1:
                                            KB2level7[key2level7] = shortcut2level4four
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4four = shortcut2level4four[index2level4four+1:]
                                            index2level4four=str.find(shortcut2level4four,string2search4four)
                                            if index2level4four == -1:
                                                KB2level8[key2level8] = shortcut2level4four
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2FOUR4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4FOUR: ", shortcut2level4four)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2FOUR4SEARCH *** FAILED - SHORTCUT2LEVEL4FOUR: ", shortcut2level4four)   
        
        print ("(Step 6A/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # fourfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2FOUR4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2FOUR4SEARCH - COUNT2ACK4FOUR; ", count2ack4four)
            # COUNT2ACK4FOUR;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2FOUR4SEARCH - COUNT2NACK4FOUR; ", count2nack4four)
            # COUNT2NACK4FOUR;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2FOUR4SEARCH - COUNT2FOUND4FOUR: ", count2found4four)
            # COUNT2FOUND4FOUR:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2FOUR4SEARCH - FOUND MAX SIZE: ", maxsize2ack4four)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2FOUR4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4four)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4four == 0:
                meansize2ack4four = 0
                print ("(Step 7G1/33) OF SHOOT2FOUR4SEARCH - MEAN SIZE SET: ", meansize2ack4four)
                #  
            else:       
                meansize2ack4four = int(sumsize2ack4four / count2ack4four)
                print ("(Step 7G2/33) OF SHOOT2FOUR4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4four, ", WHERE SUMSIZE2ACK4FOUR: ", sumsize2ack4four, " COUNT2ACK4FOUR: ", count2ack4four)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4FOUR:  10944512  COUNT2ACK4FOUR:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2FOUR4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4four < maxsize2file4four:
                print ("(Step 7H/33) OF SHOOT2FOUR4SEARCH - MIN SIZE MET: ", minsize2ack4four)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2FOUR4SEARCH ** MIN DEFINED: ", minsize2ack4four, " EQUALS TO MAXSIZE2FILE4FOUR: ", maxsize2file4four)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2FOUR4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2FOUR4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2FOUR4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2FOUR4SEARCH - QUEUE2FOUR: ", queue2four)
        print("(STEP 7Z3/33) OF SHOOT2FOUR4SEARCH - CONSUMER_CHANNEL2FOUR: ", consumer_channel2four) 
        print("(STEP 7Z4/33) OF SHOOT2FOUR4SEARCH - PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)
        print("(STEP 7Z5/33) OF SHOOT2FOUR4SEARCH - PATH2FOUR: ", path2four)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.fourxi.com; www.yourfourxi.com; www.yourfourxi.org; www.four2xi.com/; www.four4xi.com/; www.four8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2four4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
